<template>
  <div>
    <div class="fixed_header top-position">
      <Filter />
    </div>
    <div class="content">
      <ul class="cards">
        <news-card :item="item" v-for="item of newsList" :key="item.id" />
      </ul>
      <div class="load_more">
        <button class="btn" @click="onLoadMore">Load More</button>
      </div>
    </div>
  </div>
</template>
<script>
import NewsCard from "../components/NewsCard";
import Filter from "../components/SearchFilter.vue";
export default {
  components: {
    NewsCard,
    Filter,
  },
  data() {
    return {
      pageSize: 8,
    };
  },
  watch: {
    searchOption: {
      handler() {
        this.getData();
      },
      deep: true,
    },
  },
  computed: {
    newsList() {
      return this.$store.getters.getTopNews;
    },
    searchOption() {
      return this.$store.getters.getFilters;
    },
  },
  mounted() {
    this.getData();
  },
  methods: {
    onLoadMore() {
      this.pageSize = this.pageSize + 8;
      this.$store.dispatch("setPageSize", this.pageSize).then(() => {
        this.getData();
      });
    },
    getData() {
      this.$store.dispatch("getNews");
    },
  },
};
</script>
<style scopped>
.cards {
  display: flex;
  flex-wrap: wrap;
  list-style: none;
  margin: 0;
  padding: 0;
}
.load_more {
  padding: 20px;
}
.btn {
  background-color: #777777;
  border: none;
  color: white;
  padding: 8px 10px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  font-size: 16px;
  border-radius: 5px;
}
.btn:hover {
  background-color: green;
}
.top-position {
  top: 50px;
}
</style>
